/************************************************************************/
/*									*/
/*  Definitions relating to rulers.					*/
/*									*/
/************************************************************************/

#   include	<appUnit.h>

#   include	<appRuler.h>

#   include	"docBuf.h"

typedef struct ColumnSeparator
    {
    int		csX0;
    int		csX1;
    } ColumnSeparator;

/************************************************************************/
/*									*/
/*  Routine declarations.						*/
/*									*/
/************************************************************************/

extern void * tedMakeTopRuler(	int			height,
				double			horPixPerMM,
				double			magnification,

				Pixel			forePixel,
				Pixel			backPixel,
				Pixel			topPixel,
				Pixel			bottomPixel,

				int			leftRulerWidth,
				int			rightRulerWidth,
				int			docX0,
				int			docX1,

				int			minVisible,
				int			maxVisible,
				int			rulerC1,
				int			whatUnit );

extern void * tedMakeLeftRuler(	int			width,
				double			pixPerMM,
				double			magnification,

				Pixel			forePixel,
				Pixel			backPixel,
				Pixel			topPixel,
				Pixel			bottomPixel,

				int			minUnused,
				int			maxUnused,
				int			docY0,
				int			docY1,

				int			docVisY0,
				int			docVisY1,

				int			rulerC1,
				int			whatUnit,
				int			pageStep,
				const char *		tlrPageFormat );

extern void tedFreeHorizontalRuler(	Display *	display,
					void *		voidttr );

extern void tedFreeVerticalRuler(	Display *	display,
					void *		voidtlr );

extern void tedExposeHorizontalRuler(	Widget			w,
					void *			voidttr,
					XEvent *		event );

extern void tedExposeVerticalRuler(	Widget			w,
					void *			voidttr,
					XEvent *		event );

extern void tedScrollHorizontalRuler(	void *			voidttr,
					Widget			w,
					int			d	);

extern void tedSetHorizontalRulerRange(	void *		voidttr,
					Widget		w,
					int		docVisX0,
					int		docVisX1,
					int		docBackX1 );

extern void tedAdaptHorizontalRuler(	void *		voidttr,
					Widget		w,
					int		docX0,
					int		docX1,
					int		firstIndent,
					int		leftIndent,
					int		rightIndent,
					int		rulerC1,
					int		tabCount,
					TabStop *	tabStops,
					int		andExpose );

extern void     tedHorizontalRulerTrackMouse(	Widget		w,
						void *		voidttr,
						XEvent *	event,
						unsigned int *	pChanged,
						int *		pFirstIndent,
						int *		pLeftIndent,
						int *		pRightIndent,
						int *		pTabCount,
						TabStop **	pTabStops,
						int *		pCsCount,
						ColumnSeparator ** pCs,
						void *		voided,
						DragHair	dragHair );

extern void tedHorizontalRulerConfigure( Widget			w,
					void *			voidttr,
					XEvent *		event,
					Boolean *		pRefused );

extern void tedVerticalRulerConfigure(	Widget			w,
					void *			voidtlr,
					XEvent *		event,
					Boolean *		pRefused );

extern int tedSetRulerColumns(	Widget			w,
				void *			voidttr,
				int			colX0,
				int			colX1,
				ColumnSeparator *	cs,
				int			csCount );

extern void tedSetLeftRulerRange(	void *			voidtr,
					Widget			w,
					int			docVisV0,
					int			docVisV1,
					int			docBackV1 );

extern void tedScrollLeftRuler(		void *			voidtr,
					Widget			w,
					int			d );

extern void tedAdaptLeftRuler(		void *		voidtlr,
					Widget		w,
					int		visisbleC0,
					int		visisbleC1,
					int		pageStep );
