/************************************************************************/
/*									*/
/*  Rulers, Ted specific functionality.					*/
/*									*/
/************************************************************************/

#   include	<stddef.h>
#   include	<stdlib.h>
#   include	<stdio.h>
#   include	<ctype.h>

#   include	<appFrame.h>
#   include	<appMetricRuler.h>

#   include	<debugon.h>

/************************************************************************/
/*									*/
/*  Allow a user to change the selected rectangle.			*/
/*									*/
/************************************************************************/

void appHorMetricRulerMoveHair(		void *		voided,
					int		from,
					int		to,
					int		asUpper	)
    {
    EditDocument *		ed= (EditDocument *)voided;
    Widget			w= ed->edDocumentWidget;
    Display *			display= XtDisplay( w );
    Window			win= XtWindow( w );
    GC				gc= ed->edGc;
    int				ox= ed->edVisibleRect.drX0;

    int				high;

    high= ed->edVisibleRect.drY1- ed->edVisibleRect.drY0;

    if  ( from >= 0 )
	{
	if  ( asUpper )
	    {
	    XClearArea( display, win, from- ox, 0, 2, high, True );
	    }
	else{
	    XClearArea( display, win, from- ox- 2, 0, 2, high, True );
	    }
	}

    if  ( to >= 0 )
	{
	int		screen= DefaultScreen( display );

	XSetForeground( display, gc, BlackPixel( display, screen ) );

	if  ( asUpper )
	    {
	    XFillRectangle( display, win, gc, to- ox, 0, 1, high );
	    XSetForeground( display, gc, WhitePixel( display, screen ) );
	    XFillRectangle( display, win, gc, to- ox+ 1, 0, 1, high );
	    }
	else{
	    XFillRectangle( display, win, gc, to- ox- 1, 0, 1, high );
	    XSetForeground( display, gc, WhitePixel( display, screen ) );
	    XFillRectangle( display, win, gc, to- ox- 2, 0, 1, high );
	    }
	}

    return;
    }

void appVertMetricRulerMoveHair(	void *		voided,
					int		from,
					int		to,
					int		asUpper	)
    {
    EditDocument *		ed= (EditDocument *)voided;
    Widget			w= ed->edDocumentWidget;
    Display *			display= XtDisplay( w );
    Window			win= XtWindow( w );
    GC				gc= ed->edGc;
    int				oy= ed->edVisibleRect.drY0;

    int				wide;

    wide= ed->edVisibleRect.drX1- ed->edVisibleRect.drX0;

    if  ( from >= 0 )
	{
	if  ( asUpper )
	    {
	    XClearArea( display, win, 0, from- oy, wide, 2, True );
	    }
	else{
	    XClearArea( display, win, 0, from- oy- 2, wide, 2, True );
	    }
	}

    if  ( to >= 0 )
	{
	int		screen= DefaultScreen( display );

	XSetForeground( display, gc, BlackPixel( display, screen ) );

	if  ( asUpper )
	    {
	    XFillRectangle( display, win, gc, 0, to- oy, wide, 1 );
	    XSetForeground( display, gc, WhitePixel( display, screen ) );
	    XFillRectangle( display, win, gc, 0, to- oy+ 1, wide, 1 );
	    }
	else{
	    XFillRectangle( display, win, gc, 0, to- oy- 1, wide, 1 );
	    XSetForeground( display, gc, WhitePixel( display, screen ) );
	    XFillRectangle( display, win, gc, 0, to- oy- 2, wide, 1 );
	    }
	}

    return;
    }

/************************************************************************/
/*									*/
/*  Draw a selection rectangle over the document. Strictly spoken this	*/
/*  has nothing to do with metric rulers.				*/
/*									*/
/************************************************************************/

void appDrawRectangleSelection(	DocumentRectangle *	drClip,
				DocumentRectangle *	drSelected,
				AppDrawingData *	add,
				AppColors *		ac,
				int			ox,
				int			oy,
				Window			win,
				Display *		display,
				GC			gc )
    {
    int			screen= DefaultScreen( display );

    if  ( drSelected->drX0 < 0	&&
	  drSelected->drX1 < 0	&&
	  drSelected->drY0 < 0	&&
	  drSelected->drY1 < 0	)
	{ return;	}

    XSetForeground( display, gc, BlackPixel( display, screen ) );

    if  ( drSelected->drX0 >= 0 )
	{
	XFillRectangle( display, win, gc,
			drSelected->drX0- ox- 1,
			add->addBackRect.drY0- oy,
			1,
			add->addBackRect.drY1- add->addBackRect.drY0 );
	}

    if  ( drSelected->drX1 >= 0 )
	{
	XFillRectangle( display, win, gc,
			drSelected->drX1- ox,
			add->addBackRect.drY0- oy,
			1,
			add->addBackRect.drY1- add->addBackRect.drY0 );
	}

    if  ( drSelected->drY0 >= 0 )
	{
	XFillRectangle( display, win, gc,
			add->addBackRect.drX0- ox,
			drSelected->drY0- oy- 1,
			add->addBackRect.drX1- add->addBackRect.drX0,
			1 );
	}

    if  ( drSelected->drY1 >= 0 )
	{
	XFillRectangle( display, win, gc,
			add->addBackRect.drX0- ox,
			drSelected->drY1- oy,
			add->addBackRect.drX1- add->addBackRect.drX0,
			1 );
	}

    XSetForeground( display, gc, WhitePixel( display, screen ) );

    if  ( drSelected->drX0 >= 0 )
	{
	XFillRectangle( display, win, gc,
			drSelected->drX0- ox- 2,
			add->addBackRect.drY0- oy,
			1,
			add->addBackRect.drY1- add->addBackRect.drY0 );
	}

    if  ( drSelected->drX1 >= 0 )
	{
	XFillRectangle( display, win, gc,
			drSelected->drX1- ox+ 1,
			add->addBackRect.drY0- oy,
			1,
			add->addBackRect.drY1- add->addBackRect.drY0 );
	}

    if  ( drSelected->drY0 >= 0 )
	{
	XFillRectangle( display, win, gc,
			add->addBackRect.drX0- ox,
			drSelected->drY0- oy- 2,
			add->addBackRect.drX1- add->addBackRect.drX0,
			1 );
	}

    if  ( drSelected->drY1 >= 0 )
	{
	XFillRectangle( display, win, gc,
			add->addBackRect.drX0- ox,
			drSelected->drY1+ 1- oy,
			add->addBackRect.drX1- add->addBackRect.drX0,
			1 );
	}

    return;
    }

/************************************************************************/
/*									*/
/*  Remove the rectangle selection and redraw the appropriate		*/
/*  rectangles.								*/
/*									*/
/************************************************************************/

void appRemoveRectangleSelection( DocumentRectangle *	drVisible,
				DocumentRectangle *	drSelected,
				Display *		display,
				Window			win )
    {
    int			ox= drVisible->drX0;
    int			oy= drVisible->drY0;

    int			wide= drVisible->drX1- drVisible->drX0;
    int			high= drVisible->drY1- drVisible->drY0;

    if  ( drSelected->drX0 >= 0 )
	{
	XClearArea( display, win, drSelected->drX0- ox- 2, 0, 2, high, True );

	drSelected->drX0= -1;
	}

    if  ( drSelected->drX1 >= 0 )
	{
	XClearArea( display, win,
			drSelected->drX1- ox, 0, 2, high, True );

	drSelected->drX1= -1;
	}

    if  ( drSelected->drY0 >= 0 )
	{
	XClearArea( display, win, 0, drSelected->drY0- oy- 2, wide, 2, True );

	drSelected->drY0= -1;
	}

    if  ( drSelected->drY1 >= 0 )
	{
	XClearArea( display, win, 0, drSelected->drY1- oy, wide, 2, True );

	drSelected->drY1= -1;
	}

    return;
    }

void appSetHorRectangleSelection( DocumentRectangle *	drVisible,
				DocumentRectangle *	drSelected,
				int			x0Screen,
				int			x1Screen,
				Display *		display,
				Window			win )
    {
    int			ox= drVisible->drX0;
    int			high= drVisible->drY1- drVisible->drY0;

    if  ( drSelected->drX0 != x0Screen )
	{
	if  ( drSelected->drX0 >= 0 )
	    {
	    XClearArea( display, win,
		    drSelected->drX0- ox- 2, 0, 2, high, True );
	    }

	if  ( x0Screen >= 0 )
	    {
	    XClearArea( display, win,
				x0Screen- ox- 2, 0, 2, high, True );
	    }

	drSelected->drX0= x0Screen;
	}

    if  ( drSelected->drX1 != x1Screen )
	{
	if  ( drSelected->drX1 >= 0 )
	    {
	    XClearArea( display, win,
			drSelected->drX1- ox, 0, 2, high, True );
	    }

	if  ( x1Screen >= 0 )
	    {
	    XClearArea( display, win, x1Screen- ox, 0, 2, high, True );
	    }

	drSelected->drX1= x1Screen;
	}

    return;
    }


void appSetVertRectangleSelection( DocumentRectangle *	drVisible,
				DocumentRectangle *	drSelected,
				int			y0Screen,
				int			y1Screen,
				Display *		display,
				Window			win )
    {
    int			oy= drVisible->drY0;
    int			wide= drVisible->drX1- drVisible->drX0;

    if  ( drSelected->drY0 != y0Screen )
	{
	if  ( drSelected->drY0 >= 0 )
	    {
	    XClearArea( display, win,
			    0, drSelected->drY0- oy- 2, wide, 2, True );
	    }

	if  ( y0Screen >= 0 )
	    {
	    XClearArea( display, win,
				0, y0Screen- oy- 2, wide, 2, True );
	    }

	drSelected->drY0= y0Screen;
	}

    if  ( drSelected->drY1 != y1Screen )
	{
	if  ( drSelected->drY1 >= 0 )
	    {
	    XClearArea( display, win,
			0, drSelected->drY1- oy, wide, 2, True );
	    }

	if  ( y1Screen >= 0 )
	    {
	    XClearArea( display, win,
				    0, y1Screen- oy, wide, 2, True );
	    }

	drSelected->drY1= y1Screen;
	}

    return;
    }

/************************************************************************/
/*									*/
/*  Redraw a ruler.							*/
/*									*/
/************************************************************************/

static void scanTopRulerExpose(	Widget		w,
				XtPointer	voidmr,
				XtPointer	voidcbs	)
    {
    XmDrawingAreaCallbackStruct *	cbs;

    cbs= (XmDrawingAreaCallbackStruct *)voidcbs;

    appExposeHorizontalRuler( w, voidmr, cbs->event );
    }

static void scanLeftRulerExpose(	Widget		w,
					XtPointer	voidmr,
					XtPointer	voidcbs	)
    {
    XmDrawingAreaCallbackStruct *	cbs;

    cbs= (XmDrawingAreaCallbackStruct *)voidcbs;

    appExposeVerticalRuler( w, voidmr, cbs->event );
    }

/************************************************************************/
/*									*/
/*  Make the ruler administration for the top ruler widget of a		*/
/*  document.								*/
/*									*/
/************************************************************************/

void appDocSetMetricTopRuler(	EditDocument *	ed,
				int		topRulerHeight,
				double		horPixPerMM,
				double		magnification,
				int		unitInt,
				XtEventHandler	mouseDown,
				Display *	display,
				int		screen )
    {
    AppDrawingData *	add= &(ed->edDrawingData);

    Pixel		topPixel;
    Pixel		bottomPixel;
    Pixel		forePixel;
    Pixel		backPixel;

    XtVaGetValues( ed->edTopRulerWidget,
			XmNforeground,		&forePixel,
			XmNbackground,		&backPixel,
			XmNtopShadowColor,	&topPixel,
			XmNbottomShadowColor,	&bottomPixel,
			NULL );

    ed->edTopRuler= appMakeMetricRuler(

		    topRulerHeight,		/*  sizeAcross		*/
		    horPixPerMM,		/*  pixPerMM		*/
		    magnification,		/*  magnification	*/

		    forePixel,			/*  forePixel		*/
		    backPixel,			/*  backPixel		*/
		    topPixel,			/*  topPixel		*/
		    bottomPixel,		/*  bottomPixel		*/

		    ed->edLeftRulerWidthPixels,	/*  minUnused		*/
		    ed->edRightRulerWidthPixels,/*  maxUnused		*/

		    add->addDocRect.drX0,	/*  documentC0		*/
		    add->addDocRect.drX1,	/*  documentC1		*/
		    ed->edVisibleRect.drX0,	/*  visisbleC0		*/
		    ed->edVisibleRect.drX1,	/*  visisbleC1		*/
		    add->addPaperRect.drX1,	/*  rulerC1		*/

		    unitInt );			/*  whatUnit		*/

    XtAddEventHandler( ed->edTopRulerWidget, StructureNotifyMask, False,
			appHorizontalRulerConfigure, (void *)ed->edTopRuler );

    XtAddCallback( ed->edTopRulerWidget, XmNexposeCallback, scanTopRulerExpose,
							    ed->edTopRuler );

    XtAddEventHandler( ed->edTopRulerWidget, ButtonPressMask, False,
				    mouseDown, (void *)ed );

    return;
    }

/************************************************************************/
/*									*/
/*  Make the ruler administration for the left ruler widget of a	*/
/*  document.								*/
/*									*/
/************************************************************************/
void appDocSetMetricLeftRuler(	EditDocument *	ed,
				int		leftRulerWidth,
				double		horPixPerMM,
				double		magnification,
				int		unitInt,
				XtEventHandler	mouseDown,
				Display *	display,
				int		screen )
    {
    AppDrawingData *	add= &(ed->edDrawingData);

    Pixel		topPixel;
    Pixel		bottomPixel;
    Pixel		forePixel;
    Pixel		backPixel;

    XtVaGetValues( ed->edLeftRulerWidget,
			XmNforeground,		&forePixel,
			XmNbackground,		&backPixel,
			XmNtopShadowColor,	&topPixel,
			XmNbottomShadowColor,	&bottomPixel,
			NULL );

    ed->edLeftRuler= appMakeMetricRuler(
		    leftRulerWidth,		/*  sizeAcross		*/
		    horPixPerMM,		/*  pixPerMM		*/
		    magnification,		/*  magnification	*/

		    forePixel,			/*  forePixel		*/
		    backPixel,			/*  backPixel		*/
		    topPixel,			/*  topPixel		*/
		    bottomPixel,		/*  bottomPixel		*/

		    0, 0,			/*  {min,max}Unused	*/

		    add->addDocRect.drY0,	/*  documentC0		*/
		    add->addDocRect.drY1,	/*  documentC1		*/
		    ed->edVisibleRect.drY0,	/*  visisbleC0		*/
		    ed->edVisibleRect.drY1,	/*  visisbleC1		*/
		    add->addPaperRect.drY1,	/*  rulerC1		*/

		    unitInt );			/*  whatUnit		*/

    XtAddEventHandler( ed->edLeftRulerWidget, StructureNotifyMask, False,
			appVerticalRulerConfigure, (void *)ed->edLeftRuler );

    XtAddCallback( ed->edLeftRulerWidget, XmNexposeCallback,
					scanLeftRulerExpose, ed->edLeftRuler );

    XtAddEventHandler( ed->edLeftRulerWidget, ButtonPressMask, False,
				    mouseDown, (void *)ed );

    return;
    }
