/************************************************************************/
/*									*/
/*  Definitions relating to rulers.					*/
/*									*/
/************************************************************************/

#   include	<appFrame.h>
#   include	<appRuler.h>
#   include	<appUnit.h>
#   include	<appGeo.h>

/************************************************************************/
/*									*/
/*  Routine declarations.						*/
/*									*/
/************************************************************************/

extern void * appMakeMetricRuler( int			sizeAcross,
				double			pixPerMM,
				double			magnification,

				Pixel			forePixel,
				Pixel			backPixel,
				Pixel			topPixel,
				Pixel			bottomPixel,

				int			minUnused,
				int			maxUnused,

				int			documentC0,
				int			documentC1,
				int			visibleC0,
				int			visibleC1,
				int			rulerC1,

				int			whatUnit );

extern void appFreeMetricRuler(	Display *	display,
				void *		voidmr );

extern void appExposeHorizontalRuler(	Widget			w,
					void *			voidmr,
					XEvent *		event );

extern void appExposeVerticalRuler(	Widget			w,
					void *			voidmr,
					XEvent *		event );

extern void appHorizontalRulerConfigure(	Widget		w,
						void *		voidmr,
						XEvent *	event,
						Boolean *	pRefused );

extern void appVerticalRulerConfigure(		Widget		w,
						void *		voidmr,
						XEvent *	event,
						Boolean *	pRefused );

extern void appHorizontalRulerTrackMouse(	Widget		w,
						void *		voidmr,
						int *		pChanged,
						XEvent *	pEvent,
						int *		pX0pixels,
						int *		pX1pixels,
						void *		voided,
						DragHair	dragHair );

extern void appVerticalRulerTrackMouse(	Widget		w,
						void *		voidmr,
						int *		pChanged,
						XEvent *	pEvent,
						int *		pX0pixels,
						int *		pX1pixels,
						void *		voided,
						DragHair	dragHair );

extern void appScrollHorMetricRuler(	void *			voidmr,
					Widget			w,
					int			d	);

extern void appScrollVertMetricRuler(	void *			voidmr,
					Widget			w,
					int			d	);

extern void appSetMetricRulerRange(	void *			voidmr,
				Widget			w,
				int			docVisV0,
				int			docVisV1,
				int			docBackV1 );

extern void appSetMetricRulerValues(	Widget		w,
					void *		voidmr,
					int		v0,
					int		v1 );

extern void appSetMetricRulerMagnification(	Widget		w,
					void *		voidmr,
					double		pixPerMM,
					double		magnification );

extern void appAdaptMetricRuler(	Widget		w,
				void *		voidmr,
				int		documentC1,
				int		rulerC1 );

extern void appDocSetMetricTopRuler(	EditDocument *	ed,
					int		topRulerHeight,
					double		horPixPerMM,
					double		magnification,
					int		unitInt,
					XtEventHandler	mouseDown,
					Display *	display,
					int		screen );

extern void appDocSetMetricLeftRuler(	EditDocument *	ed,
					int		topRulerHeight,
					double		horPixPerMM,
					double		magnification,
					int		unitInt,
					XtEventHandler	mouseDown,
					Display *	display,
					int		screen );

extern void appHorMetricRulerMoveHair(	void *		voided,
					int		from,
					int		to,
					int		asUpper	);

extern void appVertMetricRulerMoveHair(	void *		voided,
					int		from,
					int		to,
					int		asUpper	);

extern void appDrawRectangleSelection(	DocumentRectangle *	drClip,
					DocumentRectangle *	drSelected,
					AppDrawingData *	add,
					AppColors *		ac,
					int			ox,
					int			oy,
					Window			win,
					Display *		display,
					GC			gc );

extern void appRemoveRectangleSelection( DocumentRectangle *	drVisible,
					DocumentRectangle *	drSelected,
					Display *		display,
					Window			win );

extern void appSetHorRectangleSelection( DocumentRectangle *	drVisible,
					DocumentRectangle *	drSelected,
					int			x0Screen,
					int			x1Screen,
					Display *		display,
					Window			win );

extern void appSetVertRectangleSelection( DocumentRectangle *	drVisible,
					DocumentRectangle *	drSelected,
					int			y0Screen,
					int			y1Screen,
					Display *		display,
					Window			win );
