#   include	<appFrame.h>

/************************************************************************/
/*									*/
/*  A paper chooser to be embedded in another window.			*/
/*									*/
/************************************************************************/

typedef struct PaperChooser
    {
    Widget	pcFrame;
    Widget	pcBulletinBoard;
    Widget	pcVerticalColumn;

    Widget	pcMenu;
    Widget	pcPulldown;
    Widget	pcSizeText;

    Widget	pcOrientationRow;
    Widget	pcPortraitRadio;
    Widget	pcLandscapeRadio;

    int		pcCustomPaperSize;
    int		pcSizeChosen;
    int		pcSizeSet;
    int		pcLandscapeChosen;
    int		pcLandscapeSet;
    } PaperChooser;

# define appPaperChooserRetreshMenuWidth( pc ) \
				appPulldownRefreshWidth( (pc)->pcMenu )

/************************************************************************/
/*									*/
/*  Routine declarations.						*/
/*									*/
/************************************************************************/

extern void appPaperChooserShowWidthHeight( PaperChooser *	pc,
				const DocumentGeometry *	dg,
				int				unitInt );

extern void appPaperChooserShowSize(	PaperChooser *		pc,
					int			sizeChosen );

extern int appPaperChooserGetSize(	PaperChooser *		pc,
					int			unitInt,
					DocumentGeometry *	dg );

extern void appPaperChooserFillMenu(	PaperChooser *		pc,
					const char *		customLabel,
					XtCallbackProc		callback,
					void *			through );

extern void appPaperChooserAdaptToGeometry( PaperChooser *	pc,
					int			unitType,
					const DocumentGeometry * dg,
					int			set );

extern void appPaperSizeChosen(		Widget			w,
					PaperChooser *		pc,
					DocumentGeometry *	dg,
					int			unitType );

extern void appPaperSizeChanged(	PaperChooser *		pc,
					DocumentGeometry *	dg,
					int			unitType );

extern void appMakePaperChooserWidgets(	Widget			parent,
					const char *		title,
					PaperChooser *		pc,
					XtCallbackProc		changedCallback,
					void *			through );

extern void appPaperChooserAddOrientationToggles( PaperChooser * pc,
					const char *		portrait,
					const char *		landscape,
					XtCallbackProc		callback,
					void *			through );

extern void appPageToolShowOrientation(	PaperChooser *	pc );

extern void appPaperOrientationChosen(	Widget			w,
					XtPointer		voidtbcs,
					int *			pChanged,
					PaperChooser *		pc,
					int			unitType,
					DocumentGeometry *	dg );

extern void appPaperChooserManageWidgets( PaperChooser *	pc );

extern void appInitPaperChooser(	PaperChooser *		pc );

