/************************************************************************/
/*									*/
/*  Debugging output.							*/
/*									*/
/************************************************************************/

#   include	<stdio.h>
#   include	<stdarg.h>
#   include	<debug.h>

static FILE *	APP_DebugFile;

int appDebug(	const char *	format,
		... )
    {
    va_list	ap;
    int		ret;

    va_start( ap, format );

    if  ( ! APP_DebugFile )
	{ APP_DebugFile= stderr;	}

    ret= vfprintf( APP_DebugFile, format, ap );

    va_end( ap );

    fflush( stderr );

    return ret;
    }

int appDebugSetFile(	const char *	filename,
			const char *	mode )
    {
    APP_DebugFile= fopen( filename, mode );

    if  ( ! APP_DebugFile )
	{ SSXDEB(filename,mode,APP_DebugFile); return -1;	}

    return 0;
    }
