# ifdef DEB
#	undef DEB
#	undef SDEB
#	undef LDEB
#	undef XDEB
#	undef FDEB
#	undef SSDEB
#	undef LLDEB
#	undef FLDEB
#	undef XXDEB
#	undef SLDEB
#	undef SFDEB
#	undef LSDEB
#	undef SXDEB
#	undef XSDEB
#	undef LFDEB
#	undef FFDEB
#	undef LCDEB
# endif

#ifdef	__GNUC__
extern int appDebug(	const char *	format,
			... )
			__attribute__ (( format ( printf, 1, 2 ) ));
#else
extern int appDebug(	const char *	format,
			... );
#endif

extern int appDebugSetFile(	const char *	filename,
				const char *	mode );

# ifdef DEBUG
#	include <ctype.h>
#	define	DEB(x)	(x)
# else
#	define	DEB(x)
# endif

# define DEBS(sa)	(sa)?"\"":"", (sa)?(sa):"0x0", (sa)?"\"":""
# define DEBX(lo)	((unsigned long)(lo))

# define SDEB(st) DEB(appDebug( "%s(%3d) %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #st, DEBS(st) ))

# define LDEB(l) DEB(appDebug( "%s(%3d) %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #l, (long)(l) ))

# define ODEB(l) DEB(appDebug( "%s(%3d) %s=0%lo\n", \
			    __FILE__, __LINE__, \
			    #l, (long)(l) ))

# define XDEB(l) DEB(appDebug( "%s(%3d) %s=0x%lx\n", \
			    __FILE__, __LINE__, \
			    #l, DEBX(l) ))

# define FDEB(d) DEB(appDebug( "%s(%3d) %s=%g\n", \
			    __FILE__, __LINE__, \
			    #d, (double)(d) ))

# define CDEB(ch) DEB(appDebug( "%s(%3d) %s=0x%02x%c%c\n", \
			    __FILE__, __LINE__, \
			    #ch, (ch)&0xff, isprint((ch))?'=':' ', \
			    isprint((ch))?(ch):' '))

# define CLDEB(c1,l2) DEB(appDebug( "%s(%3d) %s=0x%02x%c%c %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #c1, (c1)&0xff, isprint((c1))?'=':' ', \
			    isprint((c1))?(c1):' ', \
			    #l2, (long)(l2) ))

# define CCDEB(c1,c2) DEB(appDebug( "%s(%3d) %s=0x%02x%c%c\t%s=0x%02x%c%c\n", \
			    __FILE__, __LINE__, \
			    #c1, (c1)&0xff, isprint((c1))?'=':' ', \
			    isprint((c1))?(c1):' ', \
			    #c2, (c2)&0xff, isprint((c2))?'=':' ', \
			    isprint((c2))?(c2):' '))

# define SSDEB(s1,s2) DEB(appDebug( "%s(%3d) %s=%s%s%s %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #s2, DEBS(s2) ))

# define LLDEB(l1,l2) DEB(appDebug( "%s(%3d) %s=%ld %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #l2, (long)(l2) ))

# define FLDEB(d1,l2) DEB(appDebug( "%s(%3d) %s=%g %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #d1, (double)(d1), \
			    #l2, (long)(l2) ))

# define XXDEB(l1,l2) DEB(appDebug( "%s(%3d) %s=0x%lx %s=0x%lx\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #l2, (long)(l2) ))

# define XLDEB(l1,l2) DEB(appDebug( "%s(%3d) %s=0x%lx %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #l1, DEBX(l1), \
			    #l2, (long)(l2) ))

# define LXDEB(l1,l2) DEB(appDebug( "%s(%3d) %s=%ld %s=0x%lx\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #l2, DEBX(l2) ))

# define SLDEB(s1,l2) DEB(appDebug( "%s(%3d) %s=%s%s%s %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #l2, (long)(l2) ))

# define SFDEB(s1,d2) DEB(appDebug( "%s(%3d) %s=%s%s%s %s=%g\n", \
			    __FILE__, __LINE__, \
			    #s1, (s1)?"\"":"", (s1)?(s1):"0x0", (s1)?"\"":"", \
			    #d2, (double)(d2) ))

# define LSDEB(l1,s2) DEB(appDebug( "%s(%3d) %s=%ld %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #s2, (s2)?"\"":"", (s2)?(s2):"0x0", (s2)?"\"":"" ))

# define SXDEB(s1,l2) DEB(appDebug( "%s(%3d) %s=%s%s%s %s=0x%lx\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #l2, DEBX(l2) ))

# define XSDEB(l1,s2) DEB(appDebug( "%s(%3d) %s=0x%lx %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #l1, DEBX(l1), \
			    #s2, DEBS(s2) ))

# define LFDEB(l1,d2) DEB(appDebug( "%s(%3d) %s=%ld %s=%g\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #d2, (double)(d2) ))

# define FFDEB(d1,d2) DEB(appDebug( "%s(%3d) %s=%g %s=%g\n", \
			    __FILE__, __LINE__, \
			    #d1, (double)(d1), \
			    #d2, (double)(d2) ))

# define LCDEB(l1,c2) DEB(appDebug( "%s(%3d) %s=%ld %s='%c'\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #c2, (int)(c2) ))

# define SLLDEB(s1,l2,l3) DEB(appDebug( "%s(%3d) %s=%s%s%s %s=%ld %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #l2, (long)(l2), \
			    #l3, (long)(l3) ))

# define LLLDEB(l1,l2,l3) DEB(appDebug( "%s(%3d) %s=%ld %s=%ld %s=%ld\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #l2, (long)(l2), \
			    #l3, (long)(l3) ))

# define LLSDEB(l1,l2,s3) DEB(appDebug( "%s(%3d) %s=%ld %s=%ld %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #l1, (long)(l1), \
			    #l2, (long)(l2), \
			    #s3, DEBS(s3) ))

# define SSXDEB(s1,s2,l3) DEB(appDebug( \
			    "%s(%3d) %s=%s%s%s %s=%s%s%s %s=0x%lx\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #s2, DEBS(s2), \
			    #l3, DEBX(l3) ))

# define SSSDEB(s1,s2,s3) DEB(appDebug( \
			    "%s(%3d) %s=%s%s%s %s=%s%s%s %s=%s%s%s\n", \
			    __FILE__, __LINE__, \
			    #s1, DEBS(s1), \
			    #s2, DEBS(s2), \
			    #s3, DEBS(s3) ))
